/**
 * Ladder, empowering Model Driven Architecture in J2EE applications
 *
 * Copyright (c) 2012, Dilip Dalton
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * See the License for the specific language governing permissions and limitations 
 * under the License.
 */

package ws.ladder.model;

public interface TypeMapper {

	public Class<?> toReference(Class<?> derivedClass);

	public Class<?> toDerived(Class<?> referenceClass);

	public MapperDirection getDirection();
	
	public void setDirection(MapperDirection direction);	
	
	public Class<?> getSourceClass(Class<?> clazz);
	
	public Class<?> getTargetClass(Class<?> clazz);
	
	public TypeMapper newInstance(MapperDirection direction);

	public EntityKey getEntityKey(Object identifier, Type type);
	
	public boolean isDerived(Class<?> clazz);
	
	public boolean isReference(Class<?> clazz);
}