/**
 * Ladder, empowering Model Driven Architecture in J2EE applications
 *
 * Copyright (c) 2012, Dilip Dalton
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * See the License for the specific language governing permissions and limitations 
 * under the License.
 */

package ws.ladder.model.event;

import ws.ladder.model.CallInfo;

public class CollectionElement implements CollectionEvent {

	private CallInfo ci;	
	private Object collection;
	private Object element;
	private Object key; // in case the collection is a Map, element is then the value

	public CollectionElement(CallInfo ci, Object collection, Object element) {
		this.ci = ci;		
		this.collection = collection;
		this.element = element;
	}
	
	public CallInfo getCallInfo() {
		return ci;
	}

	public void setCallInfo(CallInfo ci) {
		this.ci = ci;
	}	

	public Object getElement() {
		return element;
	}
	
	public Object getCollection() {
		return collection;
	}
	
	public void setKey(Object key) {
		this.key = key;
	}

	public Object getKey() {
		return key;
	}
}
