/**
 * Ladder, empowering Model Driven Architecture in J2EE applications
 *
 * Copyright (c) 2012, Dilip Dalton
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * See the License for the specific language governing permissions and limitations 
 * under the License.
 */

package ws.ladder.model.view;

import java.util.List;

public class NativeQuery {

	protected List<String>      attributeList;
	protected String            queryString;
	protected String            identifierClause;
	protected boolean           usable;
	
	public String getIdentifierClause() {
		return identifierClause;
	}

	public void setIdentifierClause(String identifier) {
		this.identifierClause = identifier;
	}	
	
	public boolean isUsable() {
		return usable;
	}
	
	public void setUsable(boolean usable) {
		this.usable = usable;
	}
	
	public List<String> getAttributeList() {
		return attributeList;
	}
	public void setAttributeList(List<String> attributeList) {
		this.attributeList = attributeList;
	}
	public String getQueryString() {
		return queryString;
	}
	public void setQueryString(String queryString) {
		this.queryString = queryString;
	} 

	/**
	 * The starting position is 1
	 * @param attribute
	 * @return
	 */
	public int getPosition(String value) {
		int result = -1;
		
		for(int i = 0; i < attributeList.size(); i++) {
			if(attributeList.get(i).equals(value)) {
				result = i;
				break;
			}
		}
		
		return result;
	}
}