/**
 * Ladder, empowering Model Driven Architecture in J2EE applications
 *
 * Copyright (c) 2012, Dilip Dalton
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * See the License for the specific language governing permissions and limitations 
 * under the License.
 */

package ws.ladder.service;

import java.util.List;
import java.util.Map;
import java.util.Set;

import ws.ladder.model.ContentDetail;
import ws.ladder.model.ContentScope;
import ws.ladder.model.Type;
import ws.ladder.model.view.ContentViews;
import ws.ladder.model.view.ViewBranch;
import ws.ladder.util.AggregatePropertyPaths;

public class MetaModel {

	protected DASFactory dasFactory;	
	
	public MetaModel(DASFactory factory) {
		this.dasFactory = factory;
	}

	protected DataAccessService getDAS() {
		DataAccessService das = dasFactory.create();

		return das;
	}

	public List<String> getAggregateList() {
		return getDAS().getAggregateList();
	}

	public List<String> getViewList() {
		return ContentViews.getViewNames();
	}
	
	public List<String> getFilterFunctionList() {
		// TODO
		return null;
	}

	/**
	 * Also provided details on framework annotations configured such as Userkey, CollectionUserkey etc...
	 * Custom setters, getters, collection add/remove, invariants
	 * @param aggregateName
	 * @return
	 */
	public Type getType(String aggregateName) {
		//TODO
		return null;
	}

	public ViewBranch getView(String viewName) {
		// TODO
		return null;
	}

	/**
	 * Same as getAttributePaths with ContentScope.SUBTREE and ContentDetail.FULL
	 * @param aggregateName
	 * @return
	 */
	public Object getAttributePaths(String aggregateName) {
		Type type = getDAS().getType(aggregateName);
		Set<String> paths = AggregatePropertyPaths.enumerate(type);
		
		return paths;
	}
	
	public Object getAttributePaths(String aggregateName, ContentScope scope, ContentDetail detail) {
		// TODO
		return null;
	}	
	
	/**
	 * List all the custom setter method names and their property name
	 */
	public Map<String, String> getCustomSetters(String aggregateName) {
		return null;
	}
	
	/**
	 * List all the custom getter method names
	 */
	public Map<String, String> getCustomGetters(String aggregateName) {
		return null;
	}	
	
	/**
	 * List all the custom getter method names
	 */
	public Map<String, String> getInvariants(String aggregateName) {
		return null;
	}	
	
	/**
	 * List all the custom getter method names
	 */
	public Map<String, String> getCollectionAdd(String aggregateName) {
		return null;
	}	
	
	/**
	 * List all the custom getter method names
	 */
	public Map<String, String> getCollectionRemove(String aggregateName) {
		return null;
	}		
}
