/**
 * Ladder, empowering Model Driven Architecture in J2EE applications
 *
 * Copyright (c) 2012, Dilip Dalton
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * See the License for the specific language governing permissions and limitations 
 * under the License.
 */

package ws.ladder.service;

import ws.ladder.util.ClassUtil;

import com.mongodb.DB;
import com.mongodb.Mongo;

public class MongoDBFactory {

	private String hostname;
	private int port;
	private String dbName;
	private String username;
	private String password;

	public DB getMongoDB() {
		Mongo mongo = null;

		try {
			if (mongo == null)
				mongo = new Mongo(hostname, port);
		} catch (Exception e) {
			throw ClassUtil.wrapRun(e);
		}
		
		DB db = mongo.getDB(dbName);
		db.authenticate(username, password.toCharArray());

		return db;
	}
}